import "reflect-metadata";
import { InjectedConstructor, ParameterProvider } from "./types";
/**
 * Converts a class constructor with parameters into a constructor with optional parameters.
 * Where possible parameter values are provided when no value is passed to the new constructor.
 * This logic is determied by the parameterProvider function.
 *
 * @param type Type to be constructed
 * @param parameterProvider function to lookup the constructor parameter value
 */
export declare function injectConstructor<T extends new (...args: any[]) => any>(type: T, parameterProvider: ParameterProvider): InjectedConstructor<T, Partial<ConstructorParameters<T>>>;
