import { FunctionWithParams, InjectedFunction, MapMeta, ParameterProvider } from "./types";
export declare function addFunctionMetadata<TFunc extends (...args: any[]) => any>(func: TFunc, meta: MapMeta<Parameters<TFunc>>): TFunc;
/**
 * Wraps a function and provides arguments from parameterProvider
 * Where possible argument values are provided when no value is passed to the new constructor.
 * This logic is determied by the parameterProvider function.
 *
 * @param type Type to be constructed
 * @param paramMetadata The types to be constructed (unfortunately this can't be done by reflection)
 * @param parameterProvider function to lookup the constructor parameter value
 */
export declare function injectFunction<TFunc extends FunctionWithParams>(func: TFunc, paramMetadata: MapMeta<Parameters<TFunc>>, parameterProvider: ParameterProvider): InjectedFunction<TFunc, Partial<Parameters<TFunc>>>;
